#include <iostream>
#include <string>
#include <sstream>
#include <stdexcept>
#include <cstdlib>

#include "ido.h"


IdoPont::IdoPont(std::string const& ido) {
    std::stringstream ss;
    uint16_t temp;
    ss<<ido;
    ss>>temp;
    ora = (uint8_t)temp;
    ss>>sep;
    ss>>temp;
    perc = (uint8_t)temp;
    char sep2;
    ss>>sep2;
    ss>>temp;
    mp = (uint8_t)temp;
    if (sep != sep2 || !helyes())
        throw std::domain_error("Hibas datumformatum");
}

IdoPont::IdoPont(uint16_t oo, uint16_t pp, uint16_t mm) :ora{(uint8_t)oo}, perc{(uint8_t)pp}, mp{(uint8_t)mm} {
    sep = ':';
}
 //private
bool IdoPont::helyes() {//uint-tel a 0<=-t nem kell nezni, de nem art
    return 0<= ora && ora<24 &&  //esetleg kovetkezo napot jelolo idopont furdok ejszakaja eseten
           0<= perc && perc<60 &&
           0<= mp && mp < 60;
}
//private
void IdoPont::check() {
    if (!helyes())
        throw std::domain_error("Hibas datumformatum");
}
void IdoPont::write(std::ostream& os) const {
    os << (uint16_t)ora << sep << (uint16_t)perc << sep << (uint16_t)mp;
}
void IdoPont::in(std::istream& is) {
    uint16_t temp;
    is>>temp;
    ora = (uint8_t)temp;
    is>>temp;
    perc = (uint8_t)temp;
    is>>temp;
    mp = (uint8_t)temp;
    if (!helyes())
        throw std::domain_error("Hibas datumformatum");
}

/*
void IdoPont::read(std::istream& is) {
    uint16_t temp;
    is>>temp;
    ora = (uint8_t)temp;
    is>>sep;
    is>>temp;
    perc = (uint8_t)temp;
    char sep2;
    is>>sep2;
    is>>temp;
    mp = (uint8_t)temp;
    if (sep != sep2 || !helyes())
        throw std::domain_error("Hibas datumformatum");
}

void IdoPont::out(std::ostream& os) const {
    os << (uint16_t)ora << " " << (uint16_t)perc << " " << (uint16_t)mp;
}
*/

/********************** IdoTartam ****************************/

void IdoTartam::writestr(std::ostream& os) const {
    os << get_ora() << ":" << get_perc() << ":" << get_mp();
}

/*
std::string IdoTartam::idostr() {
    std::stringstream ss;
    ss << get_ora() << ":" << get_perc() << ":" << get_mp();
    std::string s;
    ss >> s;
    return s;
}

void IdoTartam::in(std::istream& is) {
    uint32_t t;
    is>> t;
    secs = t;
}
void IdoTartam::out(std::ostream& os) const {
    os << secs;
}

void IdoTartam::readstr(std::istream& is){
    uint32_t ora, perc, mp;
    char qka;
    is >> ora >> qka >> perc >> qka >> mp;
    secs = 3600 * ora + 60 * perc + mp;
}

IdoTartam& IdoTartam::operator++() {
    ++secs;
    return *this;
}
IdoTartam  IdoTartam::operator++(int) {
    IdoTartam akt(*this);
    ++secs;
    return akt;
}
IdoTartam& IdoTartam::operator--() {
    --secs;
    return *this;
}
IdoTartam  IdoTartam::operator--(int) {
    IdoTartam akt(*this);
    --secs;
    return akt;
}
*/

/********************** non-member ****************************/

std::istream& operator>>(std::istream& is, IdoPont & ip) {
    ip.in(is); //a feladatban szokoz a szeparator
    return is;
}
std::ostream& operator<<(std::ostream& os, IdoPont const & ip) {
    ip.write(os); //kiiraskor ":" kell
    return os;
}
std::ostream& operator<<(std::ostream& os, IdoTartam const & it) {
    it.writestr(os);
    return os;
}

IdoTartam  operator-(IdoPont const& ig, IdoPont const& tol) {
    if(ig<tol) throw std::domain_error("negativ idotartam");
    IdoTartam t(ig.get_in_secs()-tol.get_in_secs());
    return t;
}
IdoTartam  operator+(IdoTartam const& lhs, IdoTartam const& rhs) {
    return IdoTartam(lhs.get_masodpercek()+rhs.get_masodpercek());
}
IdoTartam& operator+=(IdoTartam & lhs, IdoTartam const& rhs) {
    lhs = lhs + rhs;
    return lhs;
}


/*
std::istream& operator>>(std::istream& is, IdoTartam & it) {
    it.in(is);
    return is;
}


IdoPont  operator+(IdoPont const& ip, IdoTartam const& it) {
    uint32_t T = ip.get_in_secs()+it.get_masodpercek();
    IdoPont uj;
    uj.set_from_secs(T);
    return uj;
}

IdoPont& operator+=(IdoPont & ip,IdoTartam const& it) {
    uint32_t T = ip.get_in_secs()+it.get_masodpercek();
    ip.set_from_secs(T);
    ip = ip + it;
    return ip;
}

IdoPont  operator-(IdoPont const& ip, IdoTartam const& it) {
    uint32_t T = ip.get_in_secs();
    if (T >= it.get_masodpercek())
        T -= it.get_masodpercek();
    else throw std::domain_error("idoszamitas elotti eredmeny");
    IdoPont uj;
    uj.set_from_secs(T);
    return uj;
}

IdoPont& operator-=(IdoPont & ip, IdoTartam const& it) {
    uint32_t T = ip.get_in_secs();
    if (T >= it.get_masodpercek())
        T-= it.get_masodpercek();
    else throw std::domain_error("idoszamitas elotti eredmeny");
    ip.set_from_secs(T);
    return ip;
}

IdoTartam  operator-(IdoTartam const& lhs, IdoTartam const& rhs) {
    if (lhs<rhs) throw std::domain_error("negativ idotartam");
    IdoTartam t(lhs.get_masodpercek()-rhs.get_masodpercek());
    return t;
}
IdoTartam& operator-=(IdoTartam & lhs, IdoTartam const& rhs) {
    if (lhs<rhs ) throw std::domain_error("negativ idotartam");
    lhs = lhs-rhs;
    return lhs;
}
*/
