#ifndef IDO_H
#define IDO_H
#include <iostream>
#include <string>

class IdoPont {
  private:
    //uint8_t, mert 1 bajt eleg.
    //Mindenhol figyelni kell, hogy a stream az uint8_t-t char-nak tekinti, ezert uint16_t konverzio kell
    uint8_t ora;
    uint8_t perc;
    uint8_t mp;
    char sep;
    bool helyes();
    void check();
  public:

    IdoPont(std::string const& ido);

    IdoPont(uint16_t oo=0, uint16_t pp = 0, uint16_t mp = 0);

    /*
    IdoPont(IdoPont const& other) = default;
    IdoPont& operator=(IdoPont const& other) = default;
    ~IdoPont()= default;
    */

    uint32_t get_in_secs() const {
        return 3600*ora+60*perc+mp;
    }

    bool operator<(IdoPont const& rhs) const {
        return get_in_secs() < rhs.get_in_secs();
    }
    bool operator<=(IdoPont const& rhs) const {
        return get_in_secs() <= rhs.get_in_secs();
    }
    bool operator>=(IdoPont const& rhs) const {
        return get_in_secs() >= rhs.get_in_secs();
    }

    //sep hasznalattal
    void write(std::ostream& os)const;
    //szokozzel elvalasztott
    void in(std::istream& is);

    /*
     void set_separator(char elvalaszto) {
         sep = elvalaszto;
     }
     char get_separator() const {
         return sep;
     }
     void set_ora(uint16_t oo) {
         ora = oo;
         check();
     }
     uint16_t get_ora() const {
         return ora;
     }
     void set_perc(uint16_t pp) {
         perc = pp;
         check();
     }
     uint16_t get_perc() const {
         return perc;
     }
     void set_mp(uint16_t mm) {
         mp = mm;
         check();
     }
     uint16_t get_mp() const {
         return mp;
     }

    void set_from_secs(uint32_t secs) {
     ora = secs /3600;
     perc = (secs % 3600) / 60;
     mp = secs % 60;
    }

    bool operator==(IdoPont const& rhs) const {
     return get_in_secs() == rhs.get_in_secs();
    }
    bool operator!=(IdoPont const& rhs) const {
     return get_in_secs() != rhs.get_in_secs();
    }
    bool operator>(IdoPont const& rhs) const {
     return get_in_secs() > rhs.get_in_secs();
    }

    //sep hasznalattal
    void read(std::istream& is);
    //szokozzel elvalasztott
    void out(std::ostream& os)const;

    */

};


class IdoTartam {
  private:
    uint32_t secs;
  public:
    IdoTartam(uint32_t masodpercek = 0):secs{masodpercek} {}
    uint32_t get_masodpercek() const {
        return secs;
    }
    uint16_t get_ora() const {
        return secs / 3600;
    }
    uint16_t get_perc() const {
        return (secs-get_ora()*3600) / 60;
    }
    uint16_t get_mp() const {
        return secs % 60;
    }

    bool operator<( IdoTartam const& rhs) const {
        return secs < rhs.secs;
    }

    bool operator>( IdoTartam const& rhs) const {
        return secs > rhs.secs;
    }

    void writestr(std::ostream& os) const;

    /*

        void set_masodpercek(uint32_t masodpercek) {
            secs = masodpercek;
        }
        double get_percek() {
            return secs *1.0 / 60;
        }
        void set_percek(double perc) {
            secs = uint32_t(perc*60);
        }
        double get_orak()const {
            return secs *1.0 / 3600;
        }
        void set_orak(double ora) {
            secs = uint32_t(ora*3600);
        }

        bool operator==(IdoTartam const& rhs) const {
            return secs == rhs.secs;
        }
        bool operator!=(IdoTartam  const& rhs) const {
            return secs != rhs.secs;
        }

        bool operator>=(IdoTartam const& rhs) const {
            return secs >= rhs.secs;
        }

        bool operator<=(IdoTartam const& rhs) const {
            return secs <= rhs.secs;
        }

        std::string idostr();
        void in(std::istream& is);
        void out(std::ostream& os)const;
        void readstr(std::istream& is);

        IdoTartam& operator++();
        IdoTartam operator++(int);
        IdoTartam& operator--();
        IdoTartam operator--(int);

    */
};

std::istream& operator>>(std::istream& is, IdoPont & ip);
std::ostream& operator<<(std::ostream& os, IdoPont const & ip);
std::ostream& operator<<(std::ostream& os, IdoTartam const & it);

IdoTartam operator-(IdoPont const& tol, IdoPont const& ig);
IdoTartam operator+(IdoTartam const& lhs, IdoTartam const& rhs);
IdoTartam& operator+=(IdoTartam & lhs, IdoTartam const& rhs);


/*

std::istream& operator>>(std::istream& is, IdoTartam & it);


IdoPont operator+(IdoPont const& ip, IdoTartam const& it);
IdoPont& operator+=(IdoPont & ip,IdoTartam const& it);
IdoPont operator-(IdoPont const& ip, IdoTartam const& it);
IdoPont& operator-=(IdoPont & ip, IdoTartam const& it);


IdoTartam operator-(IdoTartam const& lhs, IdoTartam const& rhs);
IdoTartam& operator-=(IdoTartam & lhs, IdoTartam const& rhs);

*/
#endif // IDO_H
